#include "genpari.h"

#ifdef __cplusplus
  #ifdef FASTASM
char *pariversion = "                 (Fast C++ sparcv8 version)\n";
  #else
char *pariversion = "                   (C++ sparcv8 version)\n";
  #endif
#else
  #ifdef FASTASM
char *pariversion = "                  (Fast sparcv8 version)\n";
  #else
char *pariversion = "                    (Sparcv8 version)\n";
  #endif
#endif

#ifdef SOLARIS

#include <sys/times.h>
#include <limits.h>

#ifndef CLK_TCK
extern long _sysconf(int);
#define CLK_TCK _sysconf(3)
#endif

long
timer(void)
{
  static clock_t old_ticks;
  clock_t delay;
  struct tms t;
  times(&t);
  delay = (t.tms_utime - old_ticks) * (1000 / CLK_TCK);
  old_ticks = t.tms_utime;
  return (long) delay;
}

long
timer2(void)
{
  static clock_t old_ticks;
  clock_t delay;
  struct tms t;
  times(&t);
  delay = (t.tms_utime - old_ticks) * (1000 / CLK_TCK);
  old_ticks = t.tms_utime;
  return (long) delay;
}

#else
#include <sys/time.h>
#include <sys/resource.h>

long
timer(void)
{
  static long oldmusec;
  static long oldsec;
  long delay;
  struct rusage r;
  struct timeval t;
  getrusage(0,&r);t=r.ru_utime;
  delay = 1000 * (t.tv_sec - oldsec) + (t.tv_usec - oldmusec) / 1000;
  oldmusec = t.tv_usec;
  oldsec = t.tv_sec;
  return delay;
}

long
timer2(void)
{
  static long oldmusec;
  static long oldsec;
  long delay;
  struct rusage r;
  struct timeval t;
  getrusage(0,&r);t=r.ru_utime;
  delay = 1000 * (t.tv_sec - oldsec) + (t.tv_usec - oldmusec) / 1000;
  oldmusec = t.tv_usec;
  oldsec = t.tv_sec;
  return delay;
}
#endif
